ConROC.Warlock = {};

local ConROC_Warlock, ids = ...;

function ConROC:EnableRotationModule()
	self.Description = 'Warlock';
	self.NextSpell = ConROC.Warlock.Damage;

	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;	
end

function ConROC:EnableDefenseModule()
	self.NextDef = ConROC.Warlock.Defense;
end

function ConROC:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

	local Racial, Spec, Caster, Aff_Ability, Aff_Talent, Demo_Ability, Demo_Talent, Dest_Ability, Dest_Talent, Pet, Player_Buff, Player_Debuff, Target_Debuff = ids.Racial, ids.Spec, ids.Caster, ids.Aff_Ability, ids.Aff_Talent, ids.Demo_Ability, ids.Demo_Talent, ids.Dest_Ability, ids.Dest_Talent, ids.Pet, ids.Player_Buff, ids.Player_Debuff, ids.Target_Debuff;

	local _Corruption = Aff_Ability.CorruptionRank1;
	local _CurseofAgony = Aff_Ability.CurseofAgonyRank1;
	local _CurseofRecklessness = Aff_Ability.CurseofRecklessnessRank1;
	local _CurseofShadow = Aff_Ability.CurseofShadowRank1;
	local _CurseofTongues = Aff_Ability.CurseofTonguesRank1;
	local _CurseoftheElements = Aff_Ability.CurseoftheElementsRank1;
	local _CurseofWeakness = Aff_Ability.CurseofWeaknessRank1;
	local _DarkPact = Aff_Ability.DarkPactRank1;
	local _DeathCoil = Aff_Ability.DeathCoilRank1;
	local _DrainLife = Aff_Ability.DrainLifeRank1;
	local _DrainMana = Aff_Ability.DrainManaRank1;
	local _DrainSoul = Aff_Ability.DrainSoulRank1;
	local _Fear = Aff_Ability.FearRank1;
	local _HowlofTerror = Aff_Ability.HowlofTerrorRank1;
	local _LifeTap = Aff_Ability.LifeTapRank1;
	local _SiphonLife = Aff_Ability.SiphonLifeRank1;
	
	local _Banish = Demo_Ability.BanishRank1;
	local _CreateFirestone = Demo_Ability.CreateFirestoneLesser;
	local _CreateHealthstone = Demo_Ability.CreateHealthstoneMinor;
	local _CreateSpellstone = Demo_Ability.CreateSpellstone;
	local _CreateSoulstone = Demo_Ability.CreateSoulstoneMinor;
	local _DemonArmor = Demo_Ability.DemonSkinRank1;
	local _DetectInvisibility = Demo_Ability.DetectLesserInvisibility;
	local _EnslaveDemon = Demo_Ability.EnslaveDemonRank1;
	local _HealthFunnel = Demo_Ability.HealthFunnelRank1;
	local _ShadowWard = Demo_Ability.ShadowWardRank1;
	
	local _Conflagrate = Dest_Ability.ConflagrateRank1;
	local _Hellfire = Dest_Ability.HellfireRank1;
	local _Immolate = Dest_Ability.ImmolateRank1;
	local _RainofFire = Dest_Ability.RainofFireRank1;
	local _SearingPain = Dest_Ability.SearingPainRank1;
	local _ShadowBolt = Dest_Ability.ShadowBoltRank1;
	local _Shadowburn = Dest_Ability.ShadowburnRank1;
	local _SoulFire = Dest_Ability.SoulFireRank1;


function ConROC.Warlock.Damage(_, timeShift, currentSpell, gcd)
--Character
	local plvl 												= UnitLevel('player');

--Racials

--Resources
	local mana 												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manaPercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	local soulShards										= GetItemCount(6265);

--Ranks
	if IsSpellKnown(Aff_Ability.CorruptionRank6) then _Corruption = Aff_Ability.CorruptionRank6;
	elseif IsSpellKnown(Aff_Ability.CorruptionRank5) then _Corruption = Aff_Ability.CorruptionRank5;
	elseif IsSpellKnown(Aff_Ability.CorruptionRank4) then _Corruption = Aff_Ability.CorruptionRank4;
	elseif IsSpellKnown(Aff_Ability.CorruptionRank3) then _Corruption = Aff_Ability.CorruptionRank3;
	elseif IsSpellKnown(Aff_Ability.CorruptionRank2) then _Corruption = Aff_Ability.CorruptionRank2; end

	if IsSpellKnown(Aff_Ability.CurseofAgonyRank6) then _CurseofAgony = Aff_Ability.CurseofAgonyRank6;
	elseif IsSpellKnown(Aff_Ability.CurseofAgonyRank5) then _CurseofAgony = Aff_Ability.CurseofAgonyRank5;
	elseif IsSpellKnown(Aff_Ability.CurseofAgonyRank4) then _CurseofAgony = Aff_Ability.CurseofAgonyRank4;
	elseif IsSpellKnown(Aff_Ability.CurseofAgonyRank3) then _CurseofAgony = Aff_Ability.CurseofAgonyRank3;
	elseif IsSpellKnown(Aff_Ability.CurseofAgonyRank2) then _CurseofAgony = Aff_Ability.CurseofAgonyRank2; end

	if IsSpellKnown(Aff_Ability.CurseofRecklessnessRank4) then _CurseofRecklessness = Aff_Ability.CurseofRecklessnessRank4;
	elseif IsSpellKnown(Aff_Ability.CurseofRecklessnessRank3) then _CurseofRecklessness = Aff_Ability.CurseofRecklessnessRank3;
	elseif IsSpellKnown(Aff_Ability.CurseofRecklessnessRank2) then _CurseofRecklessness = Aff_Ability.CurseofRecklessnessRank2; end

	if IsSpellKnown(Aff_Ability.CurseofShadowRank2) then _CurseofShadow = Aff_Ability.CurseofShadowRank2; end

	if IsSpellKnown(Aff_Ability.CurseofTonguesRank2) then _CurseofTongues = Aff_Ability.CurseofTonguesRank2; end

	if IsSpellKnown(Aff_Ability.CurseoftheElementsRank3) then _CurseoftheElements = Aff_Ability.CurseoftheElementsRank3;
	elseif IsSpellKnown(Aff_Ability.CurseoftheElementsRank2) then _CurseoftheElements = Aff_Ability.CurseoftheElementsRank2; end

	if IsSpellKnown(Aff_Ability.CurseofWeaknessRank6) then _CurseofWeakness = Aff_Ability.CurseofWeaknessRank6;
	elseif IsSpellKnown(Aff_Ability.CurseofWeaknessRank5) then _CurseofWeakness = Aff_Ability.CurseofWeaknessRank5;
	elseif IsSpellKnown(Aff_Ability.CurseofWeaknessRank4) then _CurseofWeakness = Aff_Ability.CurseofWeaknessRank4;
	elseif IsSpellKnown(Aff_Ability.CurseofWeaknessRank3) then _CurseofWeakness = Aff_Ability.CurseofWeaknessRank3;
	elseif IsSpellKnown(Aff_Ability.CurseofWeaknessRank2) then _CurseofWeakness = Aff_Ability.CurseofWeaknessRank2; end
	
	if IsSpellKnown(Aff_Ability.DarkPactRank3) then _DarkPact = Aff_Ability.DarkPactRank3;
	elseif IsSpellKnown(Aff_Ability.DarkPactRank2) then _DarkPact = Aff_Ability.DarkPactRank2; end

	if IsSpellKnown(Aff_Ability.DeathCoilRank3) then _DeathCoil = Aff_Ability.DeathCoilRank3;
	elseif IsSpellKnown(Aff_Ability.DeathCoilRank2) then _DeathCoil = Aff_Ability.DeathCoilRank2; end

	if IsSpellKnown(Aff_Ability.DrainLifeRank6) then _DrainLife = Aff_Ability.DrainLifeRank6;
	elseif IsSpellKnown(Aff_Ability.DrainLifeRank5) then _DrainLife = Aff_Ability.DrainLifeRank5;
	elseif IsSpellKnown(Aff_Ability.DrainLifeRank4) then _DrainLife = Aff_Ability.DrainLifeRank4;
	elseif IsSpellKnown(Aff_Ability.DrainLifeRank3) then _DrainLife = Aff_Ability.DrainLifeRank3;
	elseif IsSpellKnown(Aff_Ability.DrainLifeRank2) then _DrainLife = Aff_Ability.DrainLifeRank2; end

	if IsSpellKnown(Aff_Ability.DrainManaRank4) then _DrainMana = Aff_Ability.DrainManaRank4;
	elseif IsSpellKnown(Aff_Ability.DrainManaRank3) then _DrainMana = Aff_Ability.DrainManaRank3;
	elseif IsSpellKnown(Aff_Ability.DrainManaRank2) then _DrainMana = Aff_Ability.DrainManaRank2; end
	
	if IsSpellKnown(Aff_Ability.DrainSoulRank4) then _DrainSoul = Aff_Ability.DrainSoulRank4;
	elseif IsSpellKnown(Aff_Ability.DrainSoulRank3) then _DrainSoul = Aff_Ability.DrainSoulRank3;
	elseif IsSpellKnown(Aff_Ability.DrainSoulRank2) then _DrainSoul = Aff_Ability.DrainSoulRank2; end	
	
	if IsSpellKnown(Aff_Ability.FearRank3) then _Fear = Aff_Ability.FearRank3;
	elseif IsSpellKnown(Aff_Ability.FearRank2) then _Fear = Aff_Ability.FearRank2; end

	if IsSpellKnown(Aff_Ability.HowlofTerrorRank2) then _HowlofTerror = Aff_Ability.HowlofTerrorRank2; end

	if IsSpellKnown(Aff_Ability.LifeTapRank6) then _LifeTap = Aff_Ability.LifeTapRank6;
	elseif IsSpellKnown(Aff_Ability.LifeTapRank5) then _LifeTap = Aff_Ability.LifeTapRank5;
	elseif IsSpellKnown(Aff_Ability.LifeTapRank4) then _LifeTap = Aff_Ability.LifeTapRank4;
	elseif IsSpellKnown(Aff_Ability.LifeTapRank3) then _LifeTap = Aff_Ability.LifeTapRank3;
	elseif IsSpellKnown(Aff_Ability.LifeTapRank2) then _LifeTap = Aff_Ability.LifeTapRank2; end

	if IsSpellKnown(Aff_Ability.SiphonLifeRank4) then _SiphonLife = Aff_Ability.SiphonLifeRank4;
	elseif IsSpellKnown(Aff_Ability.SiphonLifeRank3) then _SiphonLife = Aff_Ability.SiphonLifeRank3;
	elseif IsSpellKnown(Aff_Ability.SiphonLifeRank2) then _SiphonLife = Aff_Ability.SiphonLifeRank2; end

	if IsSpellKnown(Demo_Ability.BanishRank2) then _Banish = Demo_Ability.BanishRank2; end

	if IsSpellKnown(Demo_Ability.CreateFirestoneMajor) then _CreateFirestone = Demo_Ability.CreateFirestoneMajor;
	elseif IsSpellKnown(Demo_Ability.CreateFirestoneGreater) then _CreateFirestone = Demo_Ability.CreateFirestoneGreater;
	elseif IsSpellKnown(Demo_Ability.CreateFirestone) then _CreateFirestone = Demo_Ability.CreateFirestone; end

	if IsSpellKnown(Demo_Ability.CreateHealthstoneMajor) then _CreateHealthstone = Demo_Ability.CreateHealthstoneMajor;
	elseif IsSpellKnown(Demo_Ability.CreateHealthstoneGreater) then _CreateHealthstone = Demo_Ability.CreateHealthstoneGreater;
	elseif IsSpellKnown(Demo_Ability.CreateHealthstone) then _CreateHealthstone = Demo_Ability.CreateHealthstone;
	elseif IsSpellKnown(Demo_Ability.CreateHealthstoneLesser) then _CreateHealthstone = Demo_Ability.CreateHealthstoneLesser; end

	if IsSpellKnown(Demo_Ability.CreateSpellstoneMajor) then _CreateSpellstone = Demo_Ability.CreateSpellstoneMajor;
	elseif IsSpellKnown(Demo_Ability.CreateSpellstoneGreater) then _CreateSpellstone = Demo_Ability.CreateSpellstoneGreater; end

	if IsSpellKnown(Demo_Ability.CreateSoulstoneMajor) then _CreateSoulstone = Demo_Ability.CreateSoulstoneMajor;
	elseif IsSpellKnown(Demo_Ability.CreateSoulstoneGreater) then _CreateSoulstone = Demo_Ability.CreateSoulstoneGreater;
	elseif IsSpellKnown(Demo_Ability.CreateSoulstone) then _CreateSoulstone = Demo_Ability.CreateSoulstone;
	elseif IsSpellKnown(Demo_Ability.CreateSoulstoneLesser) then _CreateSoulstone = Demo_Ability.CreateSoulstoneLesser; end

	if IsSpellKnown(Demo_Ability.DetectGreaterInvisibility) then _DetectInvisibility = Demo_Ability.DetectGreaterInvisibility;
	elseif IsSpellKnown(Demo_Ability.DetectInvisibility) then _DetectInvisibility = Demo_Ability.DetectInvisibility; end
	
	if IsSpellKnown(Demo_Ability.EnslaveDemonRank3) then _EnslaveDemon = Demo_Ability.EnslaveDemonRank3;
	elseif IsSpellKnown(Demo_Ability.EnslaveDemonRank2) then _EnslaveDemon = Demo_Ability.EnslaveDemonRank2; end

	if IsSpellKnown(Demo_Ability.HealthFunnelRank7) then _HealthFunnel = Demo_Ability.HealthFunnelRank7;
	elseif IsSpellKnown(Demo_Ability.HealthFunnelRank6) then _HealthFunnel = Demo_Ability.HealthFunnelRank6;
	elseif IsSpellKnown(Demo_Ability.HealthFunnelRank5) then _HealthFunnel = Demo_Ability.HealthFunnelRank5;
	elseif IsSpellKnown(Demo_Ability.HealthFunnelRank4) then _HealthFunnel = Demo_Ability.HealthFunnelRank4;
	elseif IsSpellKnown(Demo_Ability.HealthFunnelRank3) then _HealthFunnel = Demo_Ability.HealthFunnelRank3;
	elseif IsSpellKnown(Demo_Ability.HealthFunnelRank2) then _HealthFunnel = Demo_Ability.HealthFunnelRank2; end

	if IsSpellKnown(Demo_Ability.ShadowWardRank3) then _ShadowWard = Demo_Ability.ShadowWardRank3;
	elseif IsSpellKnown(Demo_Ability.ShadowWardRank2) then _ShadowWard = Demo_Ability.ShadowWardRank2; end
	
	if IsSpellKnown(Dest_Ability.ConflagrateRank4) then _Conflagrate = Dest_Ability.ConflagrateRank4;
	elseif IsSpellKnown(Dest_Ability.ConflagrateRank3) then _Conflagrate = Dest_Ability.ConflagrateRank3;
	elseif IsSpellKnown(Dest_Ability.ConflagrateRank2) then _Conflagrate = Dest_Ability.ConflagrateRank2; end
	
	if IsSpellKnown(Dest_Ability.HellfireRank3) then _Hellfire = Dest_Ability.HellfireRank3;
	elseif IsSpellKnown(Dest_Ability.HellfireRank2) then _Hellfire = Dest_Ability.HellfireRank2; end
	
	if IsSpellKnown(Dest_Ability.ImmolateRank7) then _Immolate = Dest_Ability.ImmolateRank7;	
	elseif IsSpellKnown(Dest_Ability.ImmolateRank6) then _Immolate = Dest_Ability.ImmolateRank6;
	elseif IsSpellKnown(Dest_Ability.ImmolateRank5) then _Immolate = Dest_Ability.ImmolateRank5;
	elseif IsSpellKnown(Dest_Ability.ImmolateRank4) then _Immolate = Dest_Ability.ImmolateRank4;
	elseif IsSpellKnown(Dest_Ability.ImmolateRank3) then _Immolate = Dest_Ability.ImmolateRank3;
	elseif IsSpellKnown(Dest_Ability.ImmolateRank2) then _Immolate = Dest_Ability.ImmolateRank2; end	
	
	if IsSpellKnown(Dest_Ability.RainofFireRank4) then _RainofFire = Dest_Ability.RainofFireRank4;
	elseif IsSpellKnown(Dest_Ability.RainofFireRank3) then _RainofFire = Dest_Ability.RainofFireRank3;
	elseif IsSpellKnown(Dest_Ability.RainofFireRank2) then _RainofFire = Dest_Ability.RainofFireRank2; end	
	
	if IsSpellKnown(Dest_Ability.SearingPainRank6) then _SearingPain = Dest_Ability.SearingPainRank6;
	elseif IsSpellKnown(Dest_Ability.SearingPainRank5) then _SearingPain = Dest_Ability.SearingPainRank5;
	elseif IsSpellKnown(Dest_Ability.SearingPainRank4) then _SearingPain = Dest_Ability.SearingPainRank4;
	elseif IsSpellKnown(Dest_Ability.SearingPainRank3) then _SearingPain = Dest_Ability.SearingPainRank3;
	elseif IsSpellKnown(Dest_Ability.SearingPainRank2) then _SearingPain = Dest_Ability.SearingPainRank2; end
	
	if IsSpellKnown(Dest_Ability.ShadowBoltRank9) then _ShadowBolt = Dest_Ability.ShadowBoltRank9;
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank8) then _ShadowBolt = Dest_Ability.ShadowBoltRank8;
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank7) then _ShadowBolt = Dest_Ability.ShadowBoltRank7;	
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank6) then _ShadowBolt = Dest_Ability.ShadowBoltRank6;
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank5) then _ShadowBolt = Dest_Ability.ShadowBoltRank5;
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank4) then _ShadowBolt = Dest_Ability.ShadowBoltRank4;
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank3) then _ShadowBolt = Dest_Ability.ShadowBoltRank3;
	elseif IsSpellKnown(Dest_Ability.ShadowBoltRank2) then _ShadowBolt = Dest_Ability.ShadowBoltRank2; end

	if IsSpellKnown(Dest_Ability.ShadowburnRank6) then _Shadowburn = Dest_Ability.ShadowburnRank6;
	elseif IsSpellKnown(Dest_Ability.ShadowburnRank5) then _Shadowburn = Dest_Ability.ShadowburnRank5;
	elseif IsSpellKnown(Dest_Ability.ShadowburnRank4) then _Shadowburn = Dest_Ability.ShadowburnRank4;
	elseif IsSpellKnown(Dest_Ability.ShadowburnRank3) then _Shadowburn = Dest_Ability.ShadowburnRank3;
	elseif IsSpellKnown(Dest_Ability.ShadowburnRank2) then _Shadowburn = Dest_Ability.ShadowburnRank2; end

	if IsSpellKnown(Dest_Ability.SoulFireRank2) then _SoulFire = Dest_Ability.SoulFireRank2; end
	
--Abilities
	local sBoltRDY											= ConROC:AbilityReady(_ShadowBolt, timeShift);
	local corrRDY											= ConROC:AbilityReady(_Corruption, timeShift);
		local corrDEBUFF										= ConROC:TargetDebuff(_Corruption);
	local cofaRDY											= ConROC:AbilityReady(_CurseofAgony, timeShift);
		local cofaDEBUFF										= ConROC:TargetDebuff(_CurseofAgony);
	local slifeRDY											= ConROC:AbilityReady(_SiphonLife, timeShift);
		local slifeDEBUFF										= ConROC:TargetDebuff(_SiphonLife);
		local nfBUFF											= ConROC:Buff(Player_Buff.Nightfall, timeShift);
	local immoRDY											= ConROC:AbilityReady(_Immolate, timeShift);
		local immoDEBUFF										= ConROC:TargetDebuff(_Immolate);
	local dSoulRDY											= ConROC:AbilityReady(_DrainSoul, timeShift);
	local dLifeRDY											= ConROC:AbilityReady(_DrainLife, timeShift);
	
	local sImpRDY											= ConROC:AbilityReady(Demo_Ability.SummonImp, timeShift);

	local demoSacPOINTS										= ConROC:TalentChosen(Spec.Demonology, Demo_Talent.DemonicSacrifice);
--Conditions		
	local summoned 											= ConROC:CallPet();
--	local HasVoid											= IsSpellKnown(ids.Aff_PetAbility.ThreateningPresence, true);
	local assist 											= ConROC:PetAssist();
	local moving 											= ConROC:PlayerSpeed();
	local incombat 											= UnitAffectingCombat('player');
	local Close 											= CheckInteractDistance("target", 3);
	local targetPh 											= ConROC:PercentHealth('target');	
	local playerPh 											= ConROC:PercentHealth('player');	
	local hasWand											= HasWandEquipped();

--Indicators
	
--Warnings
	if sImpRDY and not summoned and incombat and demoSacPOINTS == 0 then
		UIErrorsFrame:AddMessage("Summon your demon!!!", 1.0, 0.0, 0.0, 53, 5);
	end
	
	if not assist and summoned and incombat then
		UIErrorsFrame:AddMessage("Pet is NOT attacking!!!", 1.0, 0.0, 0.0, 53, 5);
	end
	
--Rotations	
	if sBoltRDY and nfBUFF then
		return _ShadowBolt;
	end
	
	if dSoulRDY and targetPh <= 25 then
		return _DrainSoul;
	end
	
	if corrRDY and not corrDEBUFF and currentSpell ~= _Corruption then
		return _Corruption;
	end	
	
	if cofaRDY and not cofaDEBUFF then
		return _CurseofAgony;
	end	
	
	if slifeRDY and not slifeDEBUFF then
		return _SiphonLife;
	end		
	
	if immoRDY and not immoDEBUFF and currentSpell ~= _Immolate then
		return _Immolate;
	end		
	
	if dLifeRDY and playerPh <= 30 then
		return _DrainLife;
	end
	
	if sBoltRDY then
		return _ShadowBolt;
	end
	
	if hasWand then
		return Caster.Shoot;
	end	

	return nil;
end

function ConROC.Warlock.Defense(_, timeShift, currentSpell, gcd)
--Character
	local plvl 												= UnitLevel('player');

--Racials

--Resources
	local mana 												= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	local manaPercent 										= math.max(0, mana) / math.max(1, manaMax) * 100;
	local soulShards										= GetItemCount(6265);

--Ranks
	if IsSpellKnown(Demo_Ability.DemonArmorRank5) then _DemonArmor = Demo_Ability.DemonArmorRank5;
	elseif IsSpellKnown(Demo_Ability.DemonArmorRank4) then _DemonArmor = Demo_Ability.DemonArmorRank4;
	elseif IsSpellKnown(Demo_Ability.DemonArmorRank3) then _DemonArmor = Demo_Ability.DemonArmorRank3;
	elseif IsSpellKnown(Demo_Ability.DemonArmorRank2) then _DemonArmor = Demo_Ability.DemonArmorRank2;
	elseif IsSpellKnown(Demo_Ability.DemonArmorRank1) then _DemonArmor = Demo_Ability.DemonArmorRank1;
	elseif IsSpellKnown(Demo_Ability.DemonSkinRank2) then _DemonArmor = Demo_Ability.DemonSkinRank2; end	

--Abilities
	local dArmorRDY											= ConROC:AbilityReady(_DemonArmor, timeShift);
		local dArmorBUFF, _, dArmorDUR							= ConROC:Buff(_DemonArmor, timeShift);	
		
--Conditions	
	local petPh												= ConROC:PercentHealth('pet');
	local summoned 											= ConROC:CallPet();
	
--Rotations	
	if dArmorRDY and not dArmorBUFF then
		return _DemonArmor;
	end

	return nil;
end